unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, ExtCtrls, TeeProcs, Chart,
  StdCtrls, Series;

resourcestring

 clTemperature = 'Temperature';
 clInletTemp = 'Inlet temp';
 clInletSetTemp = 'Set inlet temp';
 clOutletTemp = 'Outlet temp';
 clOutletSetTemp = 'Set outlet temp';
 clSetRMC = 'Set RMC';
 clRMC = 'RMC';
 clTimeMin = 'Time (min)';

type
  TForm2 = class(TForm)
    Chart2: TChart;
    AreaSeries1: TAreaSeries;
    FastLineSeries2: TFastLineSeries;
    FastLineSeries3: TFastLineSeries;
    Series5: TFastLineSeries;
    FastLineSeries1: TFastLineSeries;
    Button1: TButton;
    constructor Create(AOwner : TComponent); override;
    destructor  Destroy; override;
    procedure Button1Click(Sender: TObject);
    procedure Chart2GetLegendPos(Sender: TCustomChart; Index: Integer; var X, Y,
      XColor: Integer);
  private
    { Private declarations }
    procedure InitStrings;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

// This project reproduce some kind of error in the TChart code.
// In this form the project doesnt do anything valuable, it is just
// a project to reproduce the lock/hang when filling the series.
// I was able to narrow this down by setting the min and max to 0
// and then fill the series without setting a new min and max.

// Confirmed on Windows 7 x64 SP1 machine with 12 GB RAM and 2 x ATI Radeon 5850
// ATI Catalyst driver: 11.3
// On Windows XP I have seen that the application just freeze for a few seconds
// but on Windows 7 I have to reboot the whole system.

// TChart 2010 Pro, version from feb 2011 was used


constructor TForm2.Create(AOwner : TComponent);
begin
 inherited Create(AOwner);
 // If you remove the line below, the chart will fill, otherwise it
 Chart2.BottomAxis.SetMinMax(0,0);
 InitStrings;
end;

destructor  TForm2.Destroy;
begin
 inherited Destroy;
end;

procedure TForm2.InitStrings;
begin
 Chart2.LeftAxis.Title.Caption := clTemperature;
 //clTemperature + ' ' + GetTempSign(SysConfig.Temperature);
 Chart2.RightAxis.Title.Caption := '% '+clRMC;
 Chart2.BottomAxis.Title.Caption := clTimeMin;
 AreaSeries1.Title := clRMC;
 FastLineSeries2.Title := clInletTemp;
 FastLineSeries3.Title := clInletSetTemp;
 Series5.Title := clOutletTemp;
 FastLineSeries1.Title := clOutletSetTemp;
end;

// When you click the button and fill the chart with min and max still on 0
// you will most likely notice that the application freeze
// If you try to resize the application window during this time you will have to
// reboot the system, it is not possible to kill from Process Manager.
procedure TForm2.Button1Click(Sender: TObject);
var lp0 : integer;
begin
 FastLineSeries2.Clear;
 FastLineSeries3.Clear;
 Series5.Clear;
 FastLineSeries1.Clear;
 AreaSeries1.Clear;

 for lp0 := 0 to 99 do begin
  FastLineSeries2.AddXY(lp0*0.2,Random(180));
  FastLineSeries3.AddXY(lp0*0.2,Random(60)+60);
  Series5.AddXY(lp0*0.2,Random(40)+60);
  FastLineSeries1.AddXY(lp0*0.2,80);
  AreaSeries1.AddXY(lp0*0.2,100-lp0);
 end;

// By adding the line below, it will work again.
// Chart2.BottomAxis.SetMinMax(0,20);
end;

procedure TForm2.Chart2GetLegendPos(Sender: TCustomChart; Index: Integer; var X,
  Y, XColor: Integer);
var lp0,TotW : integer;
    ACaption : string;
    TxtSize : TSize;
begin
 if Assigned(Sender) then begin
  TotW := 0;
  X := 0;
  for lp0 := 0 to Sender.SeriesCount-1 do begin
   ACaption := Sender.Series[lp0].Title;
   if GetTextExtentPoint32(Sender.Canvas.Handle, ACaption, Length(ACaption), TxtSize) then begin
    if (lp0 < Index) then inc(X,16+TxtSize.cx+16);
    inc(TotW,16+TxtSize.cx+16);
   end;
  end;
  inc(x, ((Sender.ClientWidth - (TotW-16)) div 2)+16 );
  Y := 18;
  XColor := X - 16;
 end;
end;

end.
